# dzn-runtime -- Dezyne runtime library
#
# Copyright © 2016, 2017, 2019, 2020, 2021, 2022, 2023 Janneke Nieuwenhuizen <janneke@gnu.org>
# Copyright © 2017 Jvaneerd <J.vaneerd@student.fontys.nl>
# Copyright © 2017, 2018, 2019, 2021, 2022 Rutger van Beusekom <rutger@dezyne.org>
# Copyright © 2016 Henk Katerberg <hank@mudball.nl>
# Copyright © 2024 Paul Hoogendijk <paul@dezyne.org>
#
# This file is part of dzn-runtime.
#
# All rights reserved.
#
#
# Commentary:
#
# Code:

import inspect

class Locator:
    def __init__ (self, services={}):
        self.services = services
    @staticmethod
    def key (type, key):
        type = type if inspect.isclass (type) else type.__class__
        return type.__name__ + key;
    def set (self, o, key=''):
        self.services[Locator.key (o, key)] = o
        return self
    def get (self, type, key=''):
        return self.services[Locator.key (type, key)]
    def clone (self):
        return Locator (self.services.copy ())

def main ():
    import sys
    locator = Locator ()
    i = 1
    s = 'foo'
    locator.set (i)
    locator.set (s)
    locator.set (locator)
    assert (locator.get (0) == i)
    assert (locator.get (int) == i)
    assert (locator.get ('') == s)
    assert (locator.get (str) == s)
    assert (locator.get (locator) == locator)
    assert (locator.get (Locator) == locator)
    assert (locator.get (Locator ()) == locator)
    assert (locator.clone().get (0) == i)

if __name__ == '__main__':
    main ()
# version: 2.18.2.230-5e322
